
/***************************************************************************

                                 ChessV

                   COPYRIGHT (C) 2005 BY GREGORY STRONG

This file is part of ChessV.  ChessV is free software; you can redistribute
it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the License, 
or (at your option) any later version.

ChessV is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
more details; the file 'COPYING' contains the License text, but if for
some reason you need a copy, please write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/


#ifndef FILE__PHASE_H
#define FILE__PHASE_H


class Phase
{
  protected:
	int number;

	int mobilityFactor;
	int pawnDeficiencyFactor;
	int squareValuesFactor;
	int kingSafetyFactor;
	int tropismFactor;

  public:
	//	construction
	Phase();


	//	attributes
	int GetNumber()
	{	return number;   }

	int GetMobilityFactor()
	{	return mobilityFactor;   }

	int GetPawnDeficiencyFactor()
	{	return pawnDeficiencyFactor;   }

	int GetSquareValuesFactor()
	{	return squareValuesFactor;   }

	int GetKingSafetyFactor()
	{	return kingSafetyFactor;   }

	int GetTropismFactor()
	{	return tropismFactor;   }

	void SetNumber( int phaseNumber )
	{	number = phaseNumber;   }

	void SetMobilityFactor( int factor )
	{	mobilityFactor = factor;   }

	void SetPawnDeficiencyFactor( int factor )
	{	pawnDeficiencyFactor = factor;   }

	void SetSquareValuesFactor( int factor )
	{	squareValuesFactor = factor;   }

	void SetKingSafetyFactor( int factor )
	{	kingSafetyFactor = factor;   }

	void SetTropismFactor( int factor )
	{	tropismFactor = factor;   }
};


#endif
