
/***************************************************************************

                                 ChessV

                   COPYRIGHT (C) 2005 BY GREGORY STRONG

This file is part of ChessV.  ChessV is free software; you can redistribute
it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the License, 
or (at your option) any later version.

ChessV is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
more details; the file 'COPYING' contains the License text, but if for
some reason you need a copy, please write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/


#ifndef FILE__PICKUP_H
#define FILE__PICKUP_H


class Piece;


class PickUp
{
  protected:
	Piece *piece;
	int squareNumber;
	unsigned flags;

  public:
	//	construction
	PickUp()
	{
	}

	PickUp( PickUp const &other ):
		piece(other.piece), 
		squareNumber(other.squareNumber),
		flags(other.flags)
	{
	}

	PickUp( Piece *pieceToPickUp, int pieceSquareNumber );

	PickUp( Piece *pieceToPickUp, int pieceSquareNumber, unsigned pieceFlags ):
		piece(pieceToPickUp),
		squareNumber(pieceSquareNumber),
		flags(pieceFlags)
	{
	}


	//	assignment
	PickUp &operator=( PickUp const &other )
	{
		piece = other.piece;
		squareNumber = other.squareNumber;
		flags = other.flags;
		return( *this );
	}


	//	member access
	Piece *GetPiece()
	{	return( piece );  }

	int GetSquareNumber()
	{	return( squareNumber );  }


	//	friends
	friend class MovementList;
};


#endif
